<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2013 IMIA net based solutions (info@imia.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

namespace IMIA\ImiaUser\Domain\Repository;

/**
 * @package     imia_user
 * @subpackage  Domain\Repository
 * @author      David Frerich <d.frerich@imia.de>
 */
class LanguageRepository extends \IMIA\ImiaBaseExt\Domain\Repository\NoStorageRepository
{
    /**
     * @var array
     */
    protected $defaultOrderings = array();

    /**
     * @param \TYPO3\CMS\Extbase\Object\ObjectManagerInterface
     * @return \IMIA\ImiaComengaCommunity\Domain\Repository\LanguageRepository
     */
    public function __construct(\TYPO3\CMS\Extbase\Object\ObjectManagerInterface $objectManager)
    {
        parent::__construct($objectManager);

        if ($GLOBALS['TSFE']) {
            $langKey = $GLOBALS['TSFE']->lang;
        } else {
            $langKey = $GLOBALS['LANG']->lang;
        }

        if ($langKey == 'de') {
            $this->defaultOrderings = array(
                'lg_name_de'    => \TYPO3\CMS\Extbase\Persistence\QueryInterface::ORDER_ASCENDING,
                'lg_name_en'    => \TYPO3\CMS\Extbase\Persistence\QueryInterface::ORDER_ASCENDING,
            );
        } else {
            $this->defaultOrderings = array(
                'lg_name_en'    => \TYPO3\CMS\Extbase\Persistence\QueryInterface::ORDER_ASCENDING,
            );
        }

        return $this;
    }
}