<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2013 IMIA net based solutions (info@imia.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

namespace IMIA\ImiaUser\Domain\Repository;

/**
 * @package     imia_user
 * @subpackage  Domain\Repository
 * @author      David Frerich <d.frerich@imia.de>
 */
class UserRepository extends \IMIA\ImiaBaseExt\Domain\Repository\Repository
{
    /**
     * @var array
     */
    protected $defaultOrderings = array();

    /**
     * @param string $email
     */
    public function findOneByEmail($email)
    {
        $query = $this->createQuery();
        $query->getQuerySettings()->setIgnoreEnableFields(true);

        $query->matching(
            $query->logicalAnd(
                $query->equals('email', $email),
                $query->equals('deleted', false)
            )
        );

        return $query->setLimit(1)->execute()->current();
    }

    /**
     * @param string $username
     */
    public function findOneByUsername($username)
    {
        $query = $this->createQuery();
        $query->getQuerySettings()->setIgnoreEnableFields(true);

        $query->matching(
            $query->logicalAnd(
                $query->equals('username', $username),
                $query->equals('deleted', false)
            )
        );

        return $query->setLimit(1)->execute()->current();
    }

    /**
     * @param string $confirmToken
     */
    public function findOneByConfirmToken($confirmToken)
    {
        $query = $this->createQuery();
        $query->getQuerySettings()->setIgnoreEnableFields(true);

        $query->matching(
            $query->logicalAnd(
                $query->equals('confirmToken', $confirmToken)
            )
        );

        return $query->setLimit(1)->execute()->current();
    }

    /**
     * @param string $activateToken
     */
    public function findOneByActivateToken($activateToken)
    {
        $query = $this->createQuery();
        $query->getQuerySettings()->setIgnoreEnableFields(true);

        $query->matching(
            $query->logicalAnd(
                $query->equals('activateToken', $activateToken),
                $query->equals('deleted', false)
            )
        );

        return $query->setLimit(1)->execute()->current();
    }
}